.TH "wordmatch" "1" "Version 1.0" "D.M.Balean" "25th April 2013"
.SH "NAME"
wordmatch
.br
A Gtk pattern\-matching word or anagram finder with optional synonyms,
now using GTK 3.
.SH "SYNOPSIS"
\fBwordmatch\fP
.SH "DESCRIPTION"
The  program starts by loading the main window which the user sees,
and at this stage it is in search mode.  Select  \fB"Search for anagrams"\fP to
change to anagram mode. A minimal popup menu is obtained by clicking
the right mouse button within the window.
.br 
.sp
\fBSEARCH MODE\fP
.br 
There are three check boxes in the \fB"Options"\fP frame,  \fB"Append synonyms"\fP,
\fB"Case sensitive"\fP and \fB"Auto-include hyphens"\fP. Select as required and
enter a search pattern in the \fB"Search Pattern"\fP entry area.  There are a
few characters reserved with special meanings for pattern-matching as
follows:-
.sp
\fB*\fP 
.br
An asterisk matches any sequence of characters including none, e.g. \fBb*\fP would
select all words beginning with \fBb\fP. If \fB"Case sensitive"\fP had been
selected then words beginning with upper case  i.e. \fBB\fP would be omitted.
If \fB"Append synonyms"\fP had been selected then synonyms from the thesaurus
would be appended to each word's entry in the output if any were found.
If \fB"Auto-include hyphens"\fP had been selected then all hyphenated words
would be included. In this particular case they would have been
included in any case because \fB*\fP matches all characters.
.sp
\fB?\fP
.br
A question mark matches any single character e.g. \fBb?n\fP would match ban, bin and bun.
.sp
\fB[\fP ... \fB]\fP
.br
Square brackets enclose alternatives e.g.  \fBf[au]r\fP would match
far and fur but not fir or for.
.sp
\fB(\fP ... \fB)\fP
Round brackets enclose an alternative string of characters
within sqaure brackets e.g. \fBf[au(a?)(e?)]r\fP would find far, fair, fear
and fur.
.sp
When the pattern has been selected and the options chosen, the user
can left click \fBSEARCH\fP at the bottom of the main window and another window should
appear with the results of the search.
.br 
.sp
\fBANAGRAM MODE\fP
.br 
This is very similar to search mode. There is extra check box which
appears in the options, \fBWith Search Pattern\fP.  If this is selected then
the search pattern entry appears so that the user can choose a pattern
to which the anagram must agree. Only anagrams fitting this pattern
will be displayed in the output. If not selected, all anagrams will be
displayed. The user can choose to have synonyms displayed, hyphens can be
auto-included in the anagrams and the user can choose to make the
anagrams case sensitive. This is all very similar to the search mode above.
The anagram letters may include a question mark (\fI?\fP) for each
unknown letter in making up the anagram letters.
.br
\fB"Auto-include hyphens"\fP and \fB"Case sensitive"\fP modes also works when
searching for anagrams anagrams.
.sp
When the selections have been made,  the user can left click \fBSEARCH\fP at
the bottom of the main window and another window should
appear with the results of the anagram search.
.sp
\fBPreferences\fP and \fBClose\fP
.br
If the user clicks the \fBPreferences\fP button the user can select the sizes
preferred for the windows used by the program. The user also has the
opportunity to change the pathname of the word list that is searched so
that an alternative may be used instead. The command for the synonyms
program can also be changed.  The %s represents the word for which a
synonym is being sought. Left click the \fBOK\fP button to save the new
choices and quit preferences or left click the \fBCANCEL\fP button to quit
preferences without saving.  The preferences are saved to the file
\fI.wordmatch\fP in the user's home directory. The defaults are
\fI/usr/share/dict/words\fP and \fI/usr/bin/aiksaurus\fP. It should be noted that
\fIusr/share/dict/words\fP doesn't include "words" which include white space
e.g. "white elephant" although this would be found  by \fBwordmatch\fP if
present. I don't know if there is a list which includes such words.
.sp
To exit left click the \fBClose\fP button.
.SH "BUGS"
Probably completely covered in them so make sure the
insecticide is handy.  Use at your own risk.
.SH "AUTHOR & COPYRIGHT"
wordmatch version 1.0
.br 
Copyright (C) 2013 David M. Balean <linprogs@balean.net>
.br 
44 Wyong Road
.br 
Killarney Vale
.br 
NSW  2261
.br 
AUSTRALIA
.br 
This program is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License or, 
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

.SH "SEE ALSO"
Whatever dictionary of words and thesaurus are used. The defaults are
\fIusr/share/dict/words\fP and  \fI/usr/bin/aiksaurus\fP.