/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    wordmatch                                                 *
*Project Version: 1.0                                                       *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Thursday 25th April 2013                                  *
*                                                                           *
*Start DateStamp: 17-Jun-2011 12.37.31 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:   http://balean.net/linprogs/index.html                              *
*                                                                           *
*Project Summary:                                                           *
* Match words using wildcards with optional synonyms                        *
* or provide anagrams using wildcards with optional synonyms                *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       about.c                                                   *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       20-Apr-2013 13.39.17 -36000 0                             *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#include "about.h"

static GtkWidget *about_window = NULL;


static void callback_about_destroy(GtkWidget *widget,gpointer data)
{
about_window = NULL;
}

static void callback_about_close(GtkWidget *widget,gpointer data)
{
gtk_widget_destroy(GTK_WIDGET(about_window));
}

void callback_about(GtkWidget *widget, gpointer data)
{
if (!about_window)
  {
  GtkWidget *scrolled_window;
  GtkWidget *label;
  GtkWidget *box, *vbox;
  GtkWidget *button;

  char buffer[2048];

  g_print("callback_about\n");

  sprintf(buffer, "%s\n%s\n\n%s",
        RH_VERSION_STRING, RH_PROJECT_CONTACT ,RH_PROJECT_COPYRIGHT);

   
  about_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  g_signal_connect (G_OBJECT (about_window), "destroy",
		    G_CALLBACK (callback_about_destroy),
		    NULL);

  gtk_window_set_title (GTK_WINDOW (about_window), "About");
  gtk_widget_set_size_request (about_window,
			       about_window_width,
			       about_window_height);


  gtk_container_set_border_width(GTK_CONTAINER(about_window), 2);
  if (!ab_pixbuf)
    {
		ab_pixbuf = gtk_widget_render_icon_pixbuf(GTK_WIDGET(about_window),
                                               					GTK_STOCK_ABOUT,
																												GTK_ICON_SIZE_DIALOG);
    }
  if (ab_pixbuf) gtk_window_set_icon( GTK_WINDOW(about_window), ab_pixbuf);


 	vbox = gtk_box_new(GTK_ORIENTATION_VERTICAL, 10);
	gtk_box_set_homogeneous (GTK_BOX(vbox), FALSE);
  gtk_container_add (GTK_CONTAINER (about_window), vbox);


  scrolled_window = gtk_scrolled_window_new(NULL, NULL);

    /* the policy is one of GTK_POLICY AUTOMATIC, or GTK_POLICY_ALWAYS.
     * GTK_POLICY_AUTOMATIC will automatically decide whether you need
     * scrollbars, whereas GTK_POLICY_ALWAYS will always leave the scrollbars
     * there.  The first one is the horizontal scrollbar, the second, 
     * the vertical. */
  gtk_scrolled_window_set_policy ( GTK_SCROLLED_WINDOW(scrolled_window),
                                GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_box_pack_start(GTK_BOX(vbox), scrolled_window, TRUE, TRUE, 0);

 	box = gtk_box_new(GTK_ORIENTATION_VERTICAL, 0);
	gtk_box_set_homogeneous (GTK_BOX(box), FALSE);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_window),
					box);

  label = gtk_label_new(buffer);
  gtk_widget_show (label);
  gtk_container_add(GTK_CONTAINER(box),label);
  

 	box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 2);
	gtk_box_set_homogeneous (GTK_BOX(box), FALSE);
  gtk_box_pack_end (GTK_BOX(vbox), box, FALSE, FALSE, 0);

  // --- Create the "Close" button
  button = gtk_button_new_with_label (" Close ");

  // --- Need to close the window if they press "Close"
  g_signal_connect (G_OBJECT (button), "clicked",
		    G_CALLBACK (callback_about_close),  NULL);

  // --- Allow it to be the default button
	gtk_widget_set_can_default(GTK_WIDGET(button), TRUE);
		
  // --- Add the button to the dialog
  gtk_box_pack_end(GTK_BOX(box), 
		      button, FALSE, TRUE, 0);

  // --- Make the button the default button
  gtk_widget_grab_default (button);

  // --- Make teverything visible
	gtk_widget_show_all(about_window);
  }
}
