/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    wordmatch                                                 *
*Project Version: 1.0                                                       *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Thursday 25th April 2013                                  *
*                                                                           *
*Start DateStamp: 17-Jun-2011 12.37.31 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:   http://balean.net/linprogs/index.html                              *
*                                                                           *
*Project Summary:                                                           *
* Match words using wildcards with optional synonyms                        *
* or provide anagrams using wildcards with optional synonyms                *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       match.h                                                   *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       18-Jun-2011 21.49.50 -36000 0                             *
*                                                                           *
*File Summary:                                                              *
* Header for match.c                                                        *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef _MATCH_H
#define _MATCH_H

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define iswildcard(c) ((c=='*')||(c=='[')||(c==']')||(c=='(')||(c==')')||(c=='?')||(c=='\\'))
#define notwildcard(c) (!(iswildcard(c)))

#define STREQ(x,y)     (strcmp(x,y)==0)
#define STRIEQ(x,y)    (strcasecmp(x,y)==0)
#define STREQN(x,y,n)  (strncmp(x,y,n)==0)
#define STRIEQN(x,y,n) (strncasecmp(x,y,n)==0)

#define  UNLESS(x)      if(!(x))
#define  UNTIL(x)       while(!(x))
#define  FOREVER        for(;;)


// Potential problem in that \ is an escape character rather than a wildcard

// The character after it is a literal which may be attempting to match a wildcard

enum {
NO_PATTERN_ERROR,
NO_CHAR_ERR,
S_BRACKET_ERR,
PREV_SBRACKET_ERR,
INCOMPLETE_RANGE_ERR,
C_BRACKET_ERR,
PREV_CBRACKET_ERR,

//BRACE_ERR,
//PREV_BRACE_ERR,

BAD_C1BRACKET_ERR,
BAD_C2BRACKET_ERR,
BAD_S2BRACKET_ERR,

//BAD_BRACE1_ERR,
//BAD_BRACE2_ERR,

INTERNAL_ERR,
};



extern gboolean match(char *s, char *p, gboolean i_flag, char *end, gulong *p_error);
extern char *pattern_errTXT[];


G_END_DECLS


#endif // _MATCH_H
