/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    wordmatch                                                 *
*Project Version: 1.0                                                       *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Thursday 25th April 2013                                  *
*                                                                           *
*Start DateStamp: 17-Jun-2011 12.37.31 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:   http://balean.net/linprogs/index.html                              *
*                                                                           *
*Project Summary:                                                           *
* Match words using wildcards with optional synonyms                        *
* or provide anagrams using wildcards with optional synonyms                *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       misc.c                                                    *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       18-Jun-2011 21.50.02 -36000 0                             *
*                                                                           *
*File Summary:                                                              *
* Various functions used in common                                          *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

 
#include "misc.h"

/********************************
 * Return length of file fname  *
 * in bytes.                    *
 * Return FALSE if it fails.    *
 ********************************/

gboolean get_fsize(char *fname, size_t *size)
{
    struct stat statbuf;

    if (stat(fname, &statbuf) == 0)
		{
		*size = statbuf.st_size;
		return(TRUE);
		}
    return(FALSE);
}

char *load_file(char *pathname)
{
size_t size = 0;
ssize_t len;
int fd;
char *buffer = NULL;
	
get_fsize(pathname, &size);	
if (!size) return(NULL);

if ( (buffer = (char *)g_malloc0(size + 1)) ) /* zero byte */
	{
	/* Open the file and load it into buffer */
	fd = open(pathname, O_RDONLY);
	if (fd >= 0)
		{
		len = read(fd, buffer, size);
		if (len == size)
			{
			close(fd);
			return(buffer);
			}
		}
	}
if (buffer) g_free(buffer);
return(NULL);
}

// Create a spinner (integer values)
GtkWidget *create_spinner(int s_start, int s_min, int s_max)
{
GtkAdjustment *spinner_adj;
spinner_adj = (GtkAdjustment *) gtk_adjustment_new (s_start, s_min, s_max, 1.0, 0.0, 0.0);
// creates the spinner, with no decimal places
return( gtk_spin_button_new (spinner_adj, 1.0, 0) );
}
